/*
boolean inASafeMnuWithNoArrow() Is a simole but but effective funcvtion. When called it will return true if the current UI dosent have <any Arrows.
And as such a safe UI to Launch the down/up keaybord feature.

Added by john.wilund@gmaik.com 150329

TODO:
ADD more safe menues
*/
boolean inASafeMenuWithNoArrow(void)
{
  boolean b_returnValue = false;
  if ((menu >= 30) && (menu < 70)) b_returnValue = true;
  if ((menu == 310) && (gby_synthVoices == 4 )) b_returnValue = true;
  return b_returnValue;
}

/* 
boolean clearTheBackAndEnterKeys(boolan clear_all)
*/

/*
void setSearcOIrder(void)
Sets both the byte array searchOrder and the gb_ret according to the choises made at menu 311

Added by john.wilund@gmail.som 1504
*/
void setSearchOrder(void)
{
  gb_ret = false;
  switch (gby_synthVoices)
  {
    case 1: // MONO
      switch (gby_monoMode)
      {
        case LKHR:  // LAST KEY HIT with RETURN
          gb_ret = true;
        case LKH: // LAST KEY HIT
        case LSK: // LAST SINGLE KEY
          searchOrder[NUM_KEYS] = {(0, 12, 1, 11, 2, 10, 3, 9, 4, 8, 5, 7, 6 )};
          break;
        case HKR: // HIGH KEY with RETURN
          gb_ret = true;
        case HK:  // HIGH KEY
          searchOrder[NUM_KEYS] = {(12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 )};
          break;
        case LKR: // LOW KEY RETURN
          gb_ret = true;
        case LK:  // LOW KEY
          searchOrder[NUM_KEYS] = {(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 )};
          break;
      }
      break;
    case 2: // DUO
    case 4: // PARA
      searchOrder[NUM_KEYS] = {(0, 12, 1, 11, 2, 10, 3, 9, 4, 8, 5, 7, 6 )};
      break;
  }
}


void checkSwitches()
{
  static byte previousstate[NUM_BUTTONS];
  static byte currentstate[NUM_BUTTONS];
  static long lasttime;
  byte index;

  if (millis() < lasttime)
  {
    // we wrapped around, lets just try again
    lasttime = millis();
  }

  if ((lasttime + DEBOUNCE) > millis()) {
    // not enough time has passed to debounce
    return;
  }
  // ok we have waited DEBOUNCE milliseconds, lets reset the timer
  lasttime = millis();

  for (index = 0; index < NUM_BUTTONS; index++) // when we start, we clear out the "just" indicators
  {
    justreleased[index] = false;
    justpressed[index] = false;

    currentstate[index] = digitalRead(buttons[index]);   // read the buttons one after eachother

    if (currentstate[index] == previousstate[index]) {
      if ((pressed[index] == LOW) && (currentstate[index] == LOW)) {
        // just pressed
        justpressed[index] = true;
      }
      else if ((pressed[index] == HIGH) && (currentstate[index] == HIGH)) {
        // just released
        justreleased[index] = true;
      }
      pressed[index] = !currentstate[index];  // remember, digital HIGH means NOT pressed
    }

    previousstate[index] = currentstate[index];   // keep a running tally of the buttons
  }
}

void clearJust()
{
  for (byte index = 0; index < NUM_BUTTONS; index++) // when we start, we clear out the "just" indicators
  {
    justreleased[index] = 0;
    justpressed[index] = 0;
  }
}

void handlePresses()
{
  unSplash(); // check if we're on the splash page and deal with it

  if (pressed[13] && justpressed[14]) // fine adjust increment
  {
    if ((*adjustValue + increment) <= upperLimit)
      *adjustValue += increment;
    else
      *adjustValue = lowerLimit;

    incDecSpecials();
    shiftL = true;
    clearJust();
  }

  if (pressed[14] && justpressed[13]) // fine adjust decrement
  {
    if ((*adjustValue - increment) >= lowerLimit)
      *adjustValue -= increment;
    else
      *adjustValue = upperLimit;

    incDecSpecials();
    shiftR = true;
    clearJust();
  }

  if (justreleased[14]) // enter key
  {
    if (!shiftL && !shiftR)
    {
      switch (menu)
      {
        case 0: // SPLASH/MAIN
          switch (mainMenu)
          {
            case 0: // SYNTH
              if (synPatchLoadSave == 0) // LOAD
              {
                menu = 70;
                gotoRootDir();
                getDirCount();
                assignIncrementButtons(&dirChoice, 1, dirCount, 1);
              }
              else // SAVE
              {
                gotoRootDir();
                menu = 80;
                getDirCount();
                assignIncrementButtons(&dirChoice, 1, dirCount, 1);
              }
              valueChange = true;
              break;

            case 2: // SEQUENCER
              if (seqBankLoadSave == 0) // LOAD
              {
                gotoRootDir();
                menu = 250;
                getDirCount();
                assignIncrementButtons(&dirChoice, 1, dirCount, 1);
              }
              else // SAVE
              {
                gotoRootDir();
                menu = 260;
                getDirCount();
                assignIncrementButtons(&dirChoice, 1, dirCount, 1);
              }
              valueChange = true;
              break;

            case 3: // SETTINGS
              if (settingsConfirm)
              {
                saveSettings();
                settingsConfirm = false;
              }
              else
              {
                settingsConfirm = true;
                updateMenu();
                lcd.setCursor(0, 1);
                lcd.print("    Overwrite?  ");
              }
              break;
          }
          break;

        case 10: // OSC1
          if (osc1WaveType == 4)
          {
            menu = 11;
            gotoRootDir();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
            valueChange = true;
          }
          else if (osc1WaveType == 3)
          {
            menu = 12;
            lockPot(5);
            assignIncrementButtons(&uiPulseWidth, -285, 285, 2);
            valueChange = true;
            clearLCD();
          }
          break;

        case 11: // OSC1 - choose user waveshape
          if (!inFolder)
          {
            setFolder();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
            justEnteredFolder = true;
          }
          break;

        case 20: // OSC2
          if (osc2WaveType == 5)
          {
            menu = 21;
            gotoRootDir();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
            valueChange = true;
          }
          else if (osc2WaveType == 3)
          {
            menu = 22;
            lockPot(5);
            assignIncrementButtons(&uiPulseWidth, -285, 285, 2);
            valueChange = true;
            clearLCD();
          }
          break;

        case 21: // OSC2 - choose user waveshape
          if (!inFolder)
          {
            setFolder();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
            justEnteredFolder = true;
          }
          break;

        case 50:
          if (lfoShape == 6)
          {
            menu = 51;
            gotoRootDir();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
            valueChange = true;
          }
          break;

        case 51: // LFO - choose user waveshape
          if (!inFolder)
          {
            setFolder();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
            justEnteredFolder = true;
          }
          break;

        case 70: // LOAD PATCH
          if (!inFolder)
          {
            setFolder();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
            justEnteredFolder = true;
          }
          lockPot(5);
          break;

        case 80: // SAVE PATCH
          if (!inFolder)
          {
            setFolder();
            justEnteredFolder = true;
          }
          else if (saveConfirm)
          {
            saveConfirm = false;
            savePatch();
          }
          else
          {
            if (strcmp(fileName, saveName) == 0)
              savePatch();
            else
            {
              saveConfirm = true;
              lcd.setCursor(4, 1);
              lcd.print("Overwrite?  ");
            }
          }
          lockPot(5);
          break;

        case 200: // SEQUENCE TRIGGER
          menu = 210;
          valueChange = true;
          break;


        case 210: // SEQUENCE EDIT
          {
            if (!midiMode)
            {
              boolean keyNotes = false;
              for (byte k = 0; k < NUM_KEYS; k++)
              {
                if (pressed[k])
                  keyNotes = true;
              }
              if (keyNotes)
              {
                updateSeqNotes();
                seqEditStep = (seqEditStep + 1) % 16; // increment the edit step
              }
              else // no front pane keyboard keys are held
              {
                menu = 211;
                assignIncrementButtons(&seq[currentSeq].voice[0][seqEditStep], -39, 48, 1);
                clearLCD();
                valueChange = true;
              }
            }
            else // MIDI mode
            {
              if (updateSeqNotes()) // will return true if there were notes held and added to sequencer
                seqEditStep = (seqEditStep + 1) % 16; // increment the edit step
              else
              {
                menu = 211;
                assignIncrementButtons(&seq[currentSeq].voice[0][seqEditStep], -39, 48, 1);
                clearLCD();
                valueChange = true;
              }
            }
          }
          break;

        case 250: // LOAD SEQ BANK
          if (!inFolder)
          {
            setFolder();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
            justEnteredFolder = true;
          }
          else if (seqBankLoaded)
          {
            unpackSeqBankBuffer();
            lcd.setCursor(4, 1);
            lcd.print("Loaded!     ");
          }
          lockPot(5);
          break;

        case 260: // SAVE SEQ BANK
          if (!inFolder)
          {
            setFolder();
            justEnteredFolder = true;
          }
          else if (saveConfirm)
          {
            saveConfirm = false;
            saveBank();
          }
          else
          {
            if (strcmp(fileName, saveName) == 0)
              saveBank();
            else
            {
              saveConfirm = true;
              lcd.setCursor(4, 1);
              lcd.print("Overwrite?  ");
            }
          }
          lockPot(5);
          break;

        case 310:
          if (gby_synthVoices == 1)
          {
            menu = 311;
            updateMenu();
          }
          if (gby_synthVoices == 2)
          {
            menu = 312;
            updateMenu();
          }
          break;

        case 311:
          // if (gby_monoMode <  LK) gby_monoMode = LK; // as a guard
          // if (gby_monoMode > LKHR) gby_monoMode = LKHR; // as a guard
          valueChange = true;
          updateMenu();
          break;

        case 312:
          valueChange = true;
          updateMenu();
          break;

        default: // we should hit this when non of the above cases is valid It's time for the KbdOct to be usefull JohWil
          if ((osc1OctaveOut < MAX_OCTAVE - 1) && (osc2OctaveOut < MAX_OCTAVE - 1))
          {
            gby_kbdOctave++;
            if (menu == 310){valueChange = true; updateMenu();}
            // it wold be cool, if the tb2, coulfd flach the current ovtave (eg. CC-<C/ some were on the screen for just a seccund, Or shown allways as filled dot and unfilled dots standing in the two rows last cjhharacter place.
            osc1Octave++;
            osc2Octave++;
          }
          break;
      }
      clearJust();
    }
    else if (shiftR)
    {
      shiftR = false;
      clearJust();
    }
  }

  if (justreleased[13]) // back key
  {
    if (!shiftL && !shiftR)
    {
      switch (menu)
      {
        case 11: // OSC1 - choose user waveshape
          if (inFolder)
          {
            setFolder();
            getDirCount();
          }
          else
          {
            menu = 10;
            assignIncrementButtons(&osc1WaveType, 0, 7, 1);
            valueChange = true;
            clearLCD();
          }
          break;

        case 12: // Squ Pulse Width
          menu = 10;
          assignIncrementButtons(&osc1WaveType, 0, 7, 1);
          valueChange = true;
          lockPot(5);
          clearLCD();
          break;

        case 21: // OSC2 - choose user waveshape
          if (inFolder)
          {
            setFolder();
            getDirCount();
          }
          else
          {
            menu = 20;
            assignIncrementButtons(&osc2WaveType, 0, 7, 1);
            valueChange = true;
            clearLCD();
          }
          break;

        case 22: // Squ Pulse Width
          menu = 20;
          assignIncrementButtons(&osc2WaveType, 0, 7, 1);
          valueChange = true;
          lockPot(5);
          clearLCD();
          break;

        case 51: // LFO - choose user waveshape
          if (inFolder)
          {
            setFolder();
            getDirCount();
          }
          else
          {
            menu = 50;
            assignIncrementButtons(&lfoShape, 0, 6, 1);
            valueChange = true;
            clearLCD();
          }
          break;

        case 70: // LOAD PATCH
          if (inFolder)
          {
            setFolder();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
          }
          else
          {
            menu = 0;
            valueChange = true;
            clearLCD();
            updateMenu();
          }
          lockPot(5);
          break;

        case 80: // SAVE PATCH
          if (inFolder)
          {
            setFolder();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
          }
          else
          {
            menu = 0;
            valueChange = true;
            clearLCD();
            updateMenu();
          }
          lockPot(5);
          break;

        case 200: // SEQUENCE TRIGGER
          seqPlayStop();
          valueChange = true;
          break;

        case 210: // SEQUENCE EDIT
          seqPlayStop();
          valueChange = true;
          break;

        case 211: // SEQUENCE EDIT NOTES
          menu = 210;
          assignIncrementButtons(&seqEditStep, 0, 15, 1);
          noteRelease();
          clearLCD();
          valueChange = true;
          break;

        case 250: // LOAD SEQ BANK
          if (inFolder)
          {
            setFolder();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
          }
          else
          {
            menu = 0;
            valueChange = true;
            clearLCD();
            updateMenu();
          }
          lockPot(5);
          break;

        case 260: // SAVE SEQ BANK
          if (inFolder)
          {
            setFolder();
            getDirCount();
            assignIncrementButtons(&dirChoice, 1, dirCount, 1);
          }
          else
          {
            menu = 0;
            valueChange = true;
            clearLCD();
            updateMenu();
          }
          lockPot(5);
          break;

        case 311:
          menu = 310;
          valueChange = true;
          updateMenu();
          setSearchOrder(); // An addition to the functions called here, just once.
          break;

        case 312:
          menu = 310;
          valueChange = true;
          updateMenu();
          break;

        default: // we should hit this when non of the above cases is valid It's time for the KbdOctve (Kbd) to be usefull JohWil
          if ((osc1OctaveOut > 0) && (osc2OctaveOut > 0))
          {
            gby_kbdOctave--;
            if (menu == 310){valueChange = true; updateMenu();}
            // it wold be cool, if the tb2, coulfd flach the current ovtave (eg. CC-<C7) somewere on the screen for just a seccund
            osc1Octave--;
            osc2Octave--;
          }
          break;
      }
      clearJust();
    }
    else if (shiftL)
    {
      shiftL = false;
      clearJust();
    }
  }

  switch (menu)
  {
    case 200: // SEQ TRIGGER
      for (byte i = 0; i < 8; i++)
      {
        if (justpressed[whiteButtons[i]])
        {
          if (!seqRunning)
          {
            sourceSeq = currentSeq;
            currentSeq = i;
            selectedSeq = i;
            destinationSeq = selectedSeq;
            seqUpdateDisplay =  true;
            valueChange = true;
          }
          else
          {
            selectedSeq = i;
            sourceSeq = currentSeq;
            destinationSeq = selectedSeq;
            valueChange = true;
          }
          if (midiTriggerOut)
            midiA.sendNoteOn(midiTrigger[i], 127, midiTriggerChannel);
          clearJust();
          longPress = millis();
          copied = false;
        }
        if (pressed[whiteButtons[i]])
        {
          if ((millis() - longPress) > 500 && !copied)
            copySeq();
        }
      }
      for (byte i = 0; i < 5; i++)
      {
        if (pressed[14])
        {
          if (justpressed[1])
          {
            clearSeq();
            // clearJust();
            valueChange = true;
            shiftR = true;
          }
        }
        else if (justpressed[blackButtons[i]])
        {
          switch (i)
          {
            case 0:
              seq[currentSeq].transpose--;
              if (seqRunning)
                seqUpdateDisplay =  true;
              else
                valueChange = true;
              break;
            case 1:
              seq[currentSeq].transpose++;
              if (seqRunning)
                seqUpdateDisplay =  true;
              else
                valueChange = true;
              break;
              
            clearJust();
          }
          // clearJust();  // Moved here by john.wilund@gmail.com
        }
      }
      break;

    case 210: // SEQ EDIT
      break;

    case 211: // SEQ NOTE ENTRY
      break;
  }
}

/*
boolean handleKeyDownOrKeyUp(byte divider, byte k)
Called by my function that divides the different keystats the buttons presents at the keyboard.
This function takes a devider (soundKey, muteKey and pressedKey) together with a byte representing the key
last beeing tuched at the keyboard. It will on a job done return a true. Should it failes it will return a false.
LKH, LKHR,LKR, HKR
Added by john.wilund@gmail.com 150409
*/
boolean handleKeyDownOrKeyUp(byte divider, byte k)
{
  boolean handled = false;
  if (divider == 0) return handled; // as a guard (This should never happen.)
  if (k > NUM_KEYS) return handled;  // as a guard (This should never happen.)

  byte numVoices = getNumVoices();

  for (byte v = 0; v < numVoices; v++) {

    if (( divider == muteKey) && (voice[v]  == k))                                // *** MUTE (NON HELD) RELEASED KEY
    { // find the voice that hold the sounding key
      // The voice that sounds the key, is found. v is the voice #

      keyAssigned[voice[v]] = false;
      voice[v] = 255;
      noteRelease();

      if (!muteVoice[v]) muteVoice[v] = true;                                   // Is in use by envelopTrigger().

      if (gb_ret && gby_retStager == 1) {
        divider = soundKey;
        k = gby_oldKey;
      }
      else gby_retStager = 255;

      if (midiOut && keysOut)
        midiA.sendNoteOff(keyboardOut[v], outVelocity, midiChannel);
      justreleased[k] = false;
      handled = true;
    }

    if ((divider == soundKey )  && (voice[v] != k))                        // *** SOUND KEY
    {

      if  (((gby_monoMode == LKR) && (k > gby_oldKey) && (gby_retStager == 0)) || ((gby_monoMode == HKR) && (k < gby_oldKey) && (gby_retStager == 0))) 
      { 
        divider = pressedKey; 
        k = gby_oldKey;
       continue;
      }
      voice[v] = k;
      keyAssigned[k] = true;
      noteTrigger();
      setVeloModulation(keyVelocity);

      if (muteVoice[v] ) muteVoice[v] = false;                             // Is in use by envelopTrigger().

      if (midiOut && keysOut)
      {
        keyboardOut[v] = k + (12 * gby_kbdOctave);
        midiA.sendNoteOn(keyboardOut[v], keyVelocity, midiChannel);
      }

      if  ((gby_monoMode == LKR) && (k < gby_oldKey) && (gby_retStager == 0)) gby_retStager++;
      else if ((gby_monoMode == HKR) && (k > gby_oldKey) && (gby_retStager == 0)) gby_retStager++;
      else if (gby_monoMode == LKHR && gby_retStager == 0) gby_retStager++;
      else gby_retStager = 255;

      justpressed[k] = false;
      handled = true;
    }

    if (( divider == pressedKey) && (voice[v] == k ))                     // *** HOLD (PRESSED, HELD) KEY
    {
      keyAssigned[k] = true;
      if (muteVoice[v] ) muteVoice[v] = false;                             // Is in use by envelopTrigger().
      if (gb_ret && gby_retStager == 255) {
        gby_oldKey = k;   // When retCounter reaches 4 then make make a fake entry.
        gby_retStager = 0;
      }
      handled = true;
    }
  }
  return handled;
}

/*
boolean handleMonoAndDuoMode(void)
This is the voice-on and voice-off function for the Mono-phonic and Duo-phonic  modes.
It returns upon a readable hit at  keyboard the result of handleKeyDownorKeyUP(byte, byte)
that is true upon a success, and false on a failure, Schould this function fail its task it will return a false.

Added by john.wilund@gmail.com 150409
Slightly alterate 150502 & 150503
*/
boolean handleMonoAndDuoMode(void)
{
  boolean handled = false;
  byte numVoices = getNumVoices();

  if (soundKeys && menu != 200) // SEQ TRIGGER
  {
    for (byte sO = 0; sO < NUM_KEYS; sO++ )
    {
      byte k = searchOrder[sO]; // it's this line that gices us this many mono mode choices
      byte divider = 0;

      if ( divider == 0 ) for (byte v = 0; v < numVoices; v++)
          if ((!pressed[voice[v]]) || (justreleased[k])) divider = muteKey;                    // A newly released key was detected *** MUTE
      if (( divider == 0 ) && (!justpressed[k])  &&  (pressed[k]))  divider = pressedKey;      // A key was noticed held *** PRESSED
      if (justpressed[k]) divider = soundKey;                                                  // A newly pressed key was detcted *** SOUND

      if (divider != 0) handled = handleKeyDownOrKeyUp(divider, k);
    }
  }
  if (arp) // arp mode is active
  {
    arpLength = 0;
    for (byte k = 0; k < NUM_KEYS; k++)
    {
      if (pressed[k] && arpLength < 10)
      {
        rawArpList[arpLength] = k;
        arpLength++;
      }
    }
    if (arpLength == 0)
    {
      for (byte v = 0; v < numVoices; v++)
        voice[v] = 255;
    }
    else
      sortArp();
  }
  return handled;;
}

/*
boolean checkKeyboard()

orginal code made by MoShang

revised 150609: Added the first if-statement and the numVoices varable john.wilunf@gmail.com
              : moved a if (midimode) to makwe the paraphonic quickwe un respons
              :150412 altered the running data types to k,v and vv (Was i and j).
              :150412 made the detection somewhat qucker
*/
boolean checkKeyboard()
{
  if ((( gby_synthVoices == 4) || (midiMode)) || (( gby_synthVoices == 1) && (gby_monoMode == LSK)))
  {
    byte numVoices = getNumVoices();
    if (midiMode) // Added by john.wilund@gmail.com 150312
    { // 150412
      for (byte k = 0; k < NUM_KEYS; k++)
      {
        if (justpressed[k])
        {
          // if (midiMode) // switch to listening to notes from front-panel keyboard 150412
          //  {            // 150412 john.wilund@gmail.com
          midiMode = false;
          monoMode = false;
          if (lastFilterCutoff != 0)
            filterCutoff = lastFilterCutoff;
          clearHeld();
          //  }          // 150412
          // clearJust(false, false, true);
        }
      }
    }
    else if (!midiMode)
    {
      if (soundKeys && menu != 200) // SEQ TRIGGER
      {
        voiceCounter = numVoices; // how mnany voices are used?
        for (byte v = 0; v < numVoices; v++) // check if a previously held note has b released
        {
          if (voice[v] != 255)
          {
            if (!pressed[voice[v]])
            {
              keyAssigned[voice[v]] = false;
              voice[v] = 255;
              voiceCounter--;
              if (midiOut && keysOut)
                midiA.sendNoteOff(keyboardOut[v], outVelocity, midiChannel);
            }
          }
          else //
            voiceCounter--;
        }

      if (voiceCounter == 0 && lastVoiceCount != 0)
        noteRelease();

        for (byte k = 0; k < NUM_KEYS; k++) // assign note to empty voice
        {
          if (!keyAssigned[k]) // if this key isn't already assigned, look for an empty voice for it
          {
            if (pressed[k])
            {
              byte v = 0;
              while (voice[v] != 255 && v < numVoices) // go to the next voice if this voice isn't free
                v++;
              if (v < numVoices)  // As a guard!!
              {
                if (midiOut && keysOut)
                {
                  keyboardOut[v] = k + 60;
                  midiA.sendNoteOn(keyboardOut[v], keyVelocity, midiChannel);
                }
                voice[v] = k;
                keyAssigned[k] = true;
                noteTrigger();
                setVeloModulation(keyVelocity);
                if (voiceCounter == 0)
                {
                  voiceCounter++;
                  for (byte vv = 0; vv < numVoices; vv++)
                  {
                    if (vv != v)
                      muteVoice[vv] = true;
                  }
                }
              }
            }
          }
        }
        lastVoiceCount = voiceCounter;
      }
      else if (arp)// arp mode is active
      {
        arpLength = 0;
        for (int k = 0; k < NUM_KEYS; k++)
        {
          if (pressed[k] && arpLength < 10)
          {
            rawArpList[arpLength] = k;
            arpLength++;
          }
        }
        if (arpLength == 0)
        {
          for (int v = 0; v < numVoices; v++)
            voice[v] = 255;
        }
        else
          sortArp();
      }
    }
  }
  else return handleMonoAndDuoMode(); // Used mostly by monophonic mode and duophonic mode
}


void assignIncrementButtons(int *adjVar, int low, int up, int inc) // variable address, lower limit, upper limit, increment
{
  adjustValue = adjVar;
  lowerLimit = low;
  upperLimit = up;
  increment = inc;
}

void incDecSpecials()
{
  // special cases
  if (adjustValue == &dirChoice && dirCount != 0)
    prepNextChoice();

  else if (adjustValue == &osc1WaveType)
    setOsc1WaveType(*adjustValue);

  else if (adjustValue == &osc2WaveType)
    setOsc2WaveType(*adjustValue);

  else if (adjustValue == &filterResonance)
    setFilterResonance(filterResonance);

  else if (adjustValue == &filterType)
    setFilterType(filterType);

  else if (adjustValue == &lfoShape)
    setLfoShape(lfoShape);

  else if (adjustValue == &tmpLfoRate)
  {
    if (lfoLowRange)
    {
      assignIncrementButtons(&tmpLfoRate, 0, 63, 1);
      lfoRate = 64 - tmpLfoRate;
      userLfoRate = lfoRate;
    }
    else // high range
    {
      assignIncrementButtons(&tmpLfoRate, 0, 1023, 4);
      lfoRate = 1024 - tmpLfoRate; // 1024 here because we don't want the rate to ever be 0;
      userLfoRate = lfoRate;
    }
    velLfoRate = lfoRate;
  }

  else if (adjustValue == &mainMenu)
    updateMenu();

  else if (adjustValue == &synPatchLoadSave)
    updateMenu();

  else if (adjustValue == &seqBankLoadSave)
    updateMenu();

  else if (adjustValue == &arp)
    clearHeld();

  else if (adjustValue == &bpm)
  {
    setBpm();
    if (menu == 220)
      seq[currentSeq].bpm = bpm;
  }

  else if (adjustValue == &arpForward)
    sortArp();

  else if (adjustValue == &osc1Volume)
    createOsc1Volume();

  else if (adjustValue == &osc2Volume)
    createOsc2Volume();

  else if (adjustValue == &shaperType)
    createWaveShaper();

  else if (adjustValue == &shaperType1PotVal)
  {
    float tmp = (float)shaperType1PotVal / 1024;
    waveShapeAmount = tmp;
    createWaveShaper();
  }

  else if (adjustValue == &waveShapeAmount2)
    createWaveShaper();

  else if (adjustValue == &gainAmountPotVal)
  {
    float tmp = (float)gainAmountPotVal / 1024;
    tmp += 1.0;
    gainAmount = tmp;
    createGainTable();
  }

  else if (adjustValue == &midiSync)
    setSyncType();

  // evaluate seperately for the sake of the else
  if (adjustValue == &menuChoice)
  {
    lockTimer = millis();
    switch (mainMenu)
    {
      case 0: // synth
        menu = synthMenu[*adjustValue];
        break;
      case 1: // arp
        menu = arpMenu[*adjustValue];
        break;
      case 2: // sequencer
        menu = seqMenu[*adjustValue];
        break;
    }
    updateMenu();
  }
  else
  {
    valueChange = true;
    lockPot(5);
  }
}

void unSplash()
{
  if (splash)
  {
    if (justpressed[13] || justpressed[14])
    {
      if (justpressed[13])
        shiftL = true;
      else if (justpressed[14])
        shiftR = true;
      customCharacters();
      splash = false;
      updateMenu();
      clearJust();
    }
  }
}


/*
byte getNumVoices(void) returns the number of actual voices that TB2 neds to perform as advertised

Addded by john.wilund@gmail.com 150328
*/
byte getNumVoices(void)
{
  byte numVoices;
  if ((gby_synthVoices < 1) || (gby_synthVoices > 4))
  {
    numVoices = 4;
    gby_synthVoices = 4;
    return numVoices;    // As a guard
  }
  numVoices = gby_synthVoices;
  return numVoices;
}


void clearHeld() // makes sure no keys or voices are assigned
{
  byte numVoices = getNumVoices();

  for (byte v = 0; v < numVoices; v++)
    voice[v] = 255;
  for (byte k = 0; k < NUM_KEYS; k++)
    keyAssigned[k] = false;
}

